# frozen_string_literal: true

module Bulkrax
  class CrcFolderComplexSubjectEntry < CrcFolderEntry
    def build
      raise CrcDatasetCreatedError unless crc_dataset_created?

      complex_subject = ComplexSubject.new(self.raw_metadata.slice('subject_species', 'subject_type', 'subject_sex', 'subject_age'))
      complex_subject.subject_title = raw_metadata['title']
      complex_subject.source_identifier = identifier
      complex_subject.parent_source_identifier = self.raw_metadata['parents']

      if complex_subject.save
        self.status_info
      end
    end

    def factory_class
      ComplexSubject
    end

    def crc_dataset_created?
      ::CrcDataset.where(source: self.raw_metadata['parents']).present?
    end
  end
end
