require "./lib/vocabularies/rdms"
# frozen_string_literal: true
# Generated by hyrax:models:install
class FileSet < ActiveFedora::Base
  self.indexer = CrcFileSetIndexer

  after_save :create_file_set_with_fast_load_meta_data
  after_destroy :destroy_set_meta_data

  property :for_complex_identifier, predicate: ::RDF::Vocab::Rdms.forComplexIdentifier, multiple: false  do |index|
    index.as :stored_searchable, :facetable
  end

  property :for_complex_type, predicate: ::RDF::Vocab::Rdms.forComplexType, multiple: false  do |index|
    index.as :stored_searchable, :facetable
  end
  include ::Hyrax::FileSetBehavior

  def fast_load_meta_data
    FileSetFastLoadMetadata.find_by(fedora_file_set_id: id)
  end

  private

  def create_file_set_with_fast_load_meta_data
    work_source_identifier = self.for_complex_identifier || self.parent_works.first&.source&.first
    work_type = self.for_complex_type || "CrcDataset"
    
    metadata = FileSetFastLoadMetadata.find_or_initialize_by(fedora_file_set_id: self.id)
    metadata.work_source_identifier = work_source_identifier
    metadata.work_model_name = work_type
    metadata.file_set_title = self.title&.first || self.label
    metadata.save
  end

  def destroy_set_meta_data
    meta_data = FileSetFastLoadMetadata.find_by(fedora_file_set_id: self.id)
    meta_data.destroy! if meta_data.present?
  end
end
