# frozen_string_literal: true
namespace :rdms do
  desc "Fix CRC 1280 collection permissions. usage: rdms:fix_crc_1280_permission"
  task fix_crc_1280_permission: :environment do
    Collection.where(crc_collection_type: "group").each do |collection|
      template = Hyrax::PermissionTemplate.find_by!(source_id: collection.id)

      collection.child_works.each do |work|
        Hyrax::PermissionTemplateApplicator.apply(template).to(model: work)

        work.save
      end
    end
  end
end